Leetcode不需要过多介绍了,今天一边开始刷题一边开始总结:
官网链接如下:https://leetcode.com/problemset/all/
题1描述:
1 | Two Sum | 38.80% | Easy |
Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.
Example:
Given nums = [2, 7, 11, 15], target = 9,Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].
C语言解法一:
/*** Note: The returned array must be malloced, assume caller calls free().*/
int* twoSum(int* nums, int numsSize, int target)
{int i, j;int *p = (int *)malloc(2*sizeof(int));for(i=0; i<numsSize-1; i++){for(j=i+1; j<numsSize; j++){if( (*(nums+i) + (*(nums+j))) == target){p[0] = i;p[1] = j; }}} return p;
}
递交结果:
复杂度分析:
时间复杂度:O(n^2),空间复杂度O(1).
解法2:
为了改善运行时间的复杂度,我们需要一种更有效的方法来检查数组中是否存在相对应的数。 如果存在,我们需要查找其索引。 维护数组中每个元素到其索引的映射的最佳方法是什么? 哈希表。
我们通过交换空间来减少从O(n)到O(1)的查找时间。 哈希表就是为此目的而构建的,它支持在接近恒定的时间内快速查找。 我说“接近”,因为如果发生碰撞,查找可能会退化为O(n)时间。 但是只要仔细选择哈希函数,查找哈希表就应该分摊O(1)时间。
一个简单的实现使用两次迭代。 在第一次迭代中,我们将每个元素的值及其索引添加到表中。 然后,在第二次迭代中,我们检查表中是否存在每个元素的补码(target-nums )。 请注意,补充不能是nums [i]本身!
class Solution {public int[] twoSum(int[] nums, int target) {Map<Integer, Integer> map = new HashMap<>();for (int i = 0; i < nums.length; i++) {int complement = target - nums[i];if (map.containsKey(complement)) {return new int[] { map.get(complement), i };}map.put(nums[i], i);}throw new IllegalArgumentException("No two sum solution");
}
}
递交结果:
复杂度分析:
时间复杂度:O(n),空间复杂度O(n).